
/**
 * Title:        MenuAppletScelta<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Aldo Giove<p>
 * Company:      <p>
 * @author Aldo Giove
 * @version 1.31
 */

package menuapplet2l;

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.util.Vector;

public class MenuAppletScelta extends Canvas {

  DatiMenuAppletScelta dati;
  boolean fSottoScelteVisibili = false;
  Color coloreTesto = Color.black,
        coloreTestoH = Color.blue,
        coloreTestoP = Color.red,
        coloreAttuale = coloreTesto;
  Image img;
  boolean fMouseDown = false;
  Vector actionListeners = new Vector();
  static boolean fDragging = false;
  //Font font = new Font("Helvetica", Font.BOLD, 12);

  static Graphics offGraphics;
  static Image offImage;
  static Dimension offDimension;

  // ------------------------------------------------------

  public MenuAppletScelta() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  // ------------------------------------------------------

  public MenuAppletScelta(DatiMenuAppletScelta d) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    assegnaDati(d);
  }

  // ------------------------------------------------------

  public void assegnaAltezza(int a)
  {
    dati.assegnaAltezza(a);
  }

  // ------------------------------------------------------

  public void assegnaColoreTesto(Color c)
  {
    coloreAttuale = coloreTesto = c;
  }

  // ------------------------------------------------------

  public void assegnaColoreTestoHighlight(Color c)
  {
    coloreTestoH = c;
  }

  // ------------------------------------------------------

  public void assegnaColoreTestoPremuto(Color c)
  {
    coloreTestoP = c;
  }

  // ------------------------------------------------------

  public Dimension getPreferredSize()
  {
    return new Dimension(dati.qualeLarghezza(), dati.qualeAltezza());
  }

  // ------------------------------------------------------

  public Dimension getMaximumSize()
  {
    return getPreferredSize();
  }

  // ------------------------------------------------------

  public Dimension getMinimumSize()
  {
    return getPreferredSize();
  }

  // ------------------------------------------------------

  // Emula il comportamento di un Button
  public void addActionListener(ActionListener al)
  {
    actionListeners.addElement(al);
  }

  // ------------------------------------------------------

  public void assegnaDati(DatiMenuAppletScelta d)
  {
    dati = d;
    img = dati.img;
  }

  // ------------------------------------------------------

  private void jbInit() throws Exception {
    this.setEnabled(true);

    this.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mouseEntered(MouseEvent e) {
        this_mouseEntered(e);
      }

      public void mouseExited(MouseEvent e) {
        this_mouseExited(e);
      }

      public void mousePressed(MouseEvent e) {
        this_mousePressed(e);
      }

      public void mouseReleased(MouseEvent e) {
        this_mouseReleased(e);
      }
    });
  }

  // ------------------------------------------------------

  public void paint(Graphics g)
  {
    update(g);
  }

  // ------------------------------------------------------

  public void update(Graphics gScreen)
  {
    Dimension d = getSize();
    int dx = 0;

    // Disegnamo off-screen, per evitare il "flicker"

    if ((offGraphics == null) ||
        (d.width != offDimension.width) ||
        (d.height != offDimension.height))
    {
      offDimension = d;
      offImage = createImage(d.width, d.height);
      offGraphics = offImage.getGraphics();
    }
    offGraphics.setColor(getBackground());
    offGraphics.fillRect(0, 0, d.width, d.height);

    Graphics g = offGraphics;

    if (img != null)
    {
      int cy = img.getHeight(this),
          cx = img.getWidth(this);
      dx += 5+cx;
      g.drawImage(img, 0, (d.height-cy)/2, this);
    }

    if (!dati.qualeTesto().equals("-"))
    {
      g.setColor(coloreAttuale);
      g.setFont(dati.font);
      g.drawString(dati.qualeTesto(), dx, d.height/2+6);
    }

    // Aggiornare lo schermo
    gScreen.drawImage(offImage, 0, 0, d.width, d.height, this);
  }

  // ------------------------------------------------------

  void this_mouseEntered(MouseEvent e) {
    if (!fDragging)
    {
      coloreAttuale = coloreTestoH;
      repaint();
      String s = dati.qualeUrl();
      if (dati.img2 != null)
        img = dati.img2;
      if (s != null && s.length() > 0)
        inviaEvento(new ActionEvent(this, -1, s));
    }
  }

  // ------------------------------------------------------

  void this_mouseExited(MouseEvent e) {
    if (!fMouseDown && !fDragging)
    {
      coloreAttuale = coloreTesto;
      img = dati.img;
      repaint();
      inviaEvento(new ActionEvent(this, -1, ""));
    }
  }

  // ------------------------------------------------------

  void this_mousePressed(MouseEvent e) {
    if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) == MouseEvent.BUTTON1_MASK)
    {
      if (dati.img3 != null)
        img = dati.img3;
      coloreAttuale = coloreTestoP;
      fMouseDown = true;
      fDragging = true;
      repaint();
    }
  }

  // ------------------------------------------------------

  void this_mouseReleased(MouseEvent e) {
    if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) == MouseEvent.BUTTON1_MASK)
    {
      img = dati.img;
      if (contains(e.getPoint()))
      {
        // Invia un evento a tutti i listener registrati
        inviaEvento(new ActionEvent(this, dati.qualeId(), dati.qualeTesto()));
        coloreAttuale = coloreTestoH;
        if (dati.img2 != null)
          img = dati.img2;
      }
      else
        coloreAttuale = coloreTesto;

      fMouseDown = false;
      fDragging = false;
      repaint();
    }
  }

  // ------------------------------------------------------

  void inviaEvento(ActionEvent ae)
  {
    int n = actionListeners.size();
    for (int i = 0; i < n; i++)
    {
      ActionListener a = (ActionListener)actionListeners.elementAt(i);
      if (a != null)
        a.actionPerformed(ae); // Invia l'evento
    }
  }
}
